(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.index = global.index || {}, global.index.js = {}), global.react));
})(this, (function (exports, React) { 'use strict';

	const DEFAULT_LANG = 'en';

	var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function getDefaultExportFromCjs (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
	}

	/**
	 * Checks if `value` is classified as an `Array` object.
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
	 * @example
	 *
	 * _.isArray([1, 2, 3]);
	 * // => true
	 *
	 * _.isArray(document.body.children);
	 * // => false
	 *
	 * _.isArray('abc');
	 * // => false
	 *
	 * _.isArray(_.noop);
	 * // => false
	 */

	var isArray$4 = Array.isArray;

	var isArray_1 = isArray$4;

	/** Detect free variable `global` from Node.js. */

	var freeGlobal$1 = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

	var _freeGlobal = freeGlobal$1;

	var freeGlobal = _freeGlobal;

	/** Detect free variable `self`. */
	var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

	/** Used as a reference to the global object. */
	var root$3 = freeGlobal || freeSelf || Function('return this')();

	var _root = root$3;

	var root$2 = _root;

	/** Built-in value references. */
	var Symbol$3 = root$2.Symbol;

	var _Symbol = Symbol$3;

	var Symbol$2 = _Symbol;

	/** Used for built-in method references. */
	var objectProto$5 = Object.prototype;

	/** Used to check objects for own properties. */
	var hasOwnProperty$4 = objectProto$5.hasOwnProperty;

	/**
	 * Used to resolve the
	 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
	 * of values.
	 */
	var nativeObjectToString$1 = objectProto$5.toString;

	/** Built-in value references. */
	var symToStringTag$1 = Symbol$2 ? Symbol$2.toStringTag : undefined;

	/**
	 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
	 *
	 * @private
	 * @param {*} value The value to query.
	 * @returns {string} Returns the raw `toStringTag`.
	 */
	function getRawTag$1(value) {
	  var isOwn = hasOwnProperty$4.call(value, symToStringTag$1),
	      tag = value[symToStringTag$1];

	  try {
	    value[symToStringTag$1] = undefined;
	    var unmasked = true;
	  } catch (e) {}

	  var result = nativeObjectToString$1.call(value);
	  if (unmasked) {
	    if (isOwn) {
	      value[symToStringTag$1] = tag;
	    } else {
	      delete value[symToStringTag$1];
	    }
	  }
	  return result;
	}

	var _getRawTag = getRawTag$1;

	/** Used for built-in method references. */

	var objectProto$4 = Object.prototype;

	/**
	 * Used to resolve the
	 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
	 * of values.
	 */
	var nativeObjectToString = objectProto$4.toString;

	/**
	 * Converts `value` to a string using `Object.prototype.toString`.
	 *
	 * @private
	 * @param {*} value The value to convert.
	 * @returns {string} Returns the converted string.
	 */
	function objectToString$1(value) {
	  return nativeObjectToString.call(value);
	}

	var _objectToString = objectToString$1;

	var Symbol$1 = _Symbol,
	    getRawTag = _getRawTag,
	    objectToString = _objectToString;

	/** `Object#toString` result references. */
	var nullTag = '[object Null]',
	    undefinedTag = '[object Undefined]';

	/** Built-in value references. */
	var symToStringTag = Symbol$1 ? Symbol$1.toStringTag : undefined;

	/**
	 * The base implementation of `getTag` without fallbacks for buggy environments.
	 *
	 * @private
	 * @param {*} value The value to query.
	 * @returns {string} Returns the `toStringTag`.
	 */
	function baseGetTag$2(value) {
	  if (value == null) {
	    return value === undefined ? undefinedTag : nullTag;
	  }
	  return (symToStringTag && symToStringTag in Object(value))
	    ? getRawTag(value)
	    : objectToString(value);
	}

	var _baseGetTag = baseGetTag$2;

	/**
	 * Checks if `value` is object-like. A value is object-like if it's not `null`
	 * and has a `typeof` result of "object".
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
	 * @example
	 *
	 * _.isObjectLike({});
	 * // => true
	 *
	 * _.isObjectLike([1, 2, 3]);
	 * // => true
	 *
	 * _.isObjectLike(_.noop);
	 * // => false
	 *
	 * _.isObjectLike(null);
	 * // => false
	 */

	function isObjectLike$1(value) {
	  return value != null && typeof value == 'object';
	}

	var isObjectLike_1 = isObjectLike$1;

	var baseGetTag$1 = _baseGetTag,
	    isObjectLike = isObjectLike_1;

	/** `Object#toString` result references. */
	var symbolTag = '[object Symbol]';

	/**
	 * Checks if `value` is classified as a `Symbol` primitive or object.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
	 * @example
	 *
	 * _.isSymbol(Symbol.iterator);
	 * // => true
	 *
	 * _.isSymbol('abc');
	 * // => false
	 */
	function isSymbol$3(value) {
	  return typeof value == 'symbol' ||
	    (isObjectLike(value) && baseGetTag$1(value) == symbolTag);
	}

	var isSymbol_1 = isSymbol$3;

	var isArray$3 = isArray_1,
	    isSymbol$2 = isSymbol_1;

	/** Used to match property names within property paths. */
	var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
	    reIsPlainProp = /^\w*$/;

	/**
	 * Checks if `value` is a property name and not a property path.
	 *
	 * @private
	 * @param {*} value The value to check.
	 * @param {Object} [object] The object to query keys on.
	 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
	 */
	function isKey$1(value, object) {
	  if (isArray$3(value)) {
	    return false;
	  }
	  var type = typeof value;
	  if (type == 'number' || type == 'symbol' || type == 'boolean' ||
	      value == null || isSymbol$2(value)) {
	    return true;
	  }
	  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
	    (object != null && value in Object(object));
	}

	var _isKey = isKey$1;

	/**
	 * Checks if `value` is the
	 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
	 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
	 * @example
	 *
	 * _.isObject({});
	 * // => true
	 *
	 * _.isObject([1, 2, 3]);
	 * // => true
	 *
	 * _.isObject(_.noop);
	 * // => true
	 *
	 * _.isObject(null);
	 * // => false
	 */

	function isObject$4(value) {
	  var type = typeof value;
	  return value != null && (type == 'object' || type == 'function');
	}

	var isObject_1 = isObject$4;

	var baseGetTag = _baseGetTag,
	    isObject$3 = isObject_1;

	/** `Object#toString` result references. */
	var asyncTag = '[object AsyncFunction]',
	    funcTag = '[object Function]',
	    genTag = '[object GeneratorFunction]',
	    proxyTag = '[object Proxy]';

	/**
	 * Checks if `value` is classified as a `Function` object.
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Lang
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
	 * @example
	 *
	 * _.isFunction(_);
	 * // => true
	 *
	 * _.isFunction(/abc/);
	 * // => false
	 */
	function isFunction$2(value) {
	  if (!isObject$3(value)) {
	    return false;
	  }
	  // The use of `Object#toString` avoids issues with the `typeof` operator
	  // in Safari 9 which returns 'object' for typed arrays and other constructors.
	  var tag = baseGetTag(value);
	  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
	}

	var isFunction_1 = isFunction$2;

	var root$1 = _root;

	/** Used to detect overreaching core-js shims. */
	var coreJsData$1 = root$1['__core-js_shared__'];

	var _coreJsData = coreJsData$1;

	var coreJsData = _coreJsData;

	/** Used to detect methods masquerading as native. */
	var maskSrcKey = (function() {
	  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
	  return uid ? ('Symbol(src)_1.' + uid) : '';
	}());

	/**
	 * Checks if `func` has its source masked.
	 *
	 * @private
	 * @param {Function} func The function to check.
	 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
	 */
	function isMasked$1(func) {
	  return !!maskSrcKey && (maskSrcKey in func);
	}

	var _isMasked = isMasked$1;

	/** Used for built-in method references. */

	var funcProto$1 = Function.prototype;

	/** Used to resolve the decompiled source of functions. */
	var funcToString$1 = funcProto$1.toString;

	/**
	 * Converts `func` to its source code.
	 *
	 * @private
	 * @param {Function} func The function to convert.
	 * @returns {string} Returns the source code.
	 */
	function toSource$1(func) {
	  if (func != null) {
	    try {
	      return funcToString$1.call(func);
	    } catch (e) {}
	    try {
	      return (func + '');
	    } catch (e) {}
	  }
	  return '';
	}

	var _toSource = toSource$1;

	var isFunction$1 = isFunction_1,
	    isMasked = _isMasked,
	    isObject$2 = isObject_1,
	    toSource = _toSource;

	/**
	 * Used to match `RegExp`
	 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
	 */
	var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

	/** Used to detect host constructors (Safari). */
	var reIsHostCtor = /^\[object .+?Constructor\]$/;

	/** Used for built-in method references. */
	var funcProto = Function.prototype,
	    objectProto$3 = Object.prototype;

	/** Used to resolve the decompiled source of functions. */
	var funcToString = funcProto.toString;

	/** Used to check objects for own properties. */
	var hasOwnProperty$3 = objectProto$3.hasOwnProperty;

	/** Used to detect if a method is native. */
	var reIsNative = RegExp('^' +
	  funcToString.call(hasOwnProperty$3).replace(reRegExpChar, '\\$&')
	  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
	);

	/**
	 * The base implementation of `_.isNative` without bad shim checks.
	 *
	 * @private
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is a native function,
	 *  else `false`.
	 */
	function baseIsNative$1(value) {
	  if (!isObject$2(value) || isMasked(value)) {
	    return false;
	  }
	  var pattern = isFunction$1(value) ? reIsNative : reIsHostCtor;
	  return pattern.test(toSource(value));
	}

	var _baseIsNative = baseIsNative$1;

	/**
	 * Gets the value at `key` of `object`.
	 *
	 * @private
	 * @param {Object} [object] The object to query.
	 * @param {string} key The key of the property to get.
	 * @returns {*} Returns the property value.
	 */

	function getValue$1(object, key) {
	  return object == null ? undefined : object[key];
	}

	var _getValue = getValue$1;

	var baseIsNative = _baseIsNative,
	    getValue = _getValue;

	/**
	 * Gets the native function at `key` of `object`.
	 *
	 * @private
	 * @param {Object} object The object to query.
	 * @param {string} key The key of the method to get.
	 * @returns {*} Returns the function if it's native, else `undefined`.
	 */
	function getNative$3(object, key) {
	  var value = getValue(object, key);
	  return baseIsNative(value) ? value : undefined;
	}

	var _getNative = getNative$3;

	var getNative$2 = _getNative;

	/* Built-in method references that are verified to be native. */
	var nativeCreate$4 = getNative$2(Object, 'create');

	var _nativeCreate = nativeCreate$4;

	var nativeCreate$3 = _nativeCreate;

	/**
	 * Removes all key-value entries from the hash.
	 *
	 * @private
	 * @name clear
	 * @memberOf Hash
	 */
	function hashClear$1() {
	  this.__data__ = nativeCreate$3 ? nativeCreate$3(null) : {};
	  this.size = 0;
	}

	var _hashClear = hashClear$1;

	/**
	 * Removes `key` and its value from the hash.
	 *
	 * @private
	 * @name delete
	 * @memberOf Hash
	 * @param {Object} hash The hash to modify.
	 * @param {string} key The key of the value to remove.
	 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
	 */

	function hashDelete$1(key) {
	  var result = this.has(key) && delete this.__data__[key];
	  this.size -= result ? 1 : 0;
	  return result;
	}

	var _hashDelete = hashDelete$1;

	var nativeCreate$2 = _nativeCreate;

	/** Used to stand-in for `undefined` hash values. */
	var HASH_UNDEFINED$1 = '__lodash_hash_undefined__';

	/** Used for built-in method references. */
	var objectProto$2 = Object.prototype;

	/** Used to check objects for own properties. */
	var hasOwnProperty$2 = objectProto$2.hasOwnProperty;

	/**
	 * Gets the hash value for `key`.
	 *
	 * @private
	 * @name get
	 * @memberOf Hash
	 * @param {string} key The key of the value to get.
	 * @returns {*} Returns the entry value.
	 */
	function hashGet$1(key) {
	  var data = this.__data__;
	  if (nativeCreate$2) {
	    var result = data[key];
	    return result === HASH_UNDEFINED$1 ? undefined : result;
	  }
	  return hasOwnProperty$2.call(data, key) ? data[key] : undefined;
	}

	var _hashGet = hashGet$1;

	var nativeCreate$1 = _nativeCreate;

	/** Used for built-in method references. */
	var objectProto$1 = Object.prototype;

	/** Used to check objects for own properties. */
	var hasOwnProperty$1 = objectProto$1.hasOwnProperty;

	/**
	 * Checks if a hash value for `key` exists.
	 *
	 * @private
	 * @name has
	 * @memberOf Hash
	 * @param {string} key The key of the entry to check.
	 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
	 */
	function hashHas$1(key) {
	  var data = this.__data__;
	  return nativeCreate$1 ? (data[key] !== undefined) : hasOwnProperty$1.call(data, key);
	}

	var _hashHas = hashHas$1;

	var nativeCreate = _nativeCreate;

	/** Used to stand-in for `undefined` hash values. */
	var HASH_UNDEFINED = '__lodash_hash_undefined__';

	/**
	 * Sets the hash `key` to `value`.
	 *
	 * @private
	 * @name set
	 * @memberOf Hash
	 * @param {string} key The key of the value to set.
	 * @param {*} value The value to set.
	 * @returns {Object} Returns the hash instance.
	 */
	function hashSet$1(key, value) {
	  var data = this.__data__;
	  this.size += this.has(key) ? 0 : 1;
	  data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
	  return this;
	}

	var _hashSet = hashSet$1;

	var hashClear = _hashClear,
	    hashDelete = _hashDelete,
	    hashGet = _hashGet,
	    hashHas = _hashHas,
	    hashSet = _hashSet;

	/**
	 * Creates a hash object.
	 *
	 * @private
	 * @constructor
	 * @param {Array} [entries] The key-value pairs to cache.
	 */
	function Hash$1(entries) {
	  var index = -1,
	      length = entries == null ? 0 : entries.length;

	  this.clear();
	  while (++index < length) {
	    var entry = entries[index];
	    this.set(entry[0], entry[1]);
	  }
	}

	// Add methods to `Hash`.
	Hash$1.prototype.clear = hashClear;
	Hash$1.prototype['delete'] = hashDelete;
	Hash$1.prototype.get = hashGet;
	Hash$1.prototype.has = hashHas;
	Hash$1.prototype.set = hashSet;

	var _Hash = Hash$1;

	/**
	 * Removes all key-value entries from the list cache.
	 *
	 * @private
	 * @name clear
	 * @memberOf ListCache
	 */

	function listCacheClear$1() {
	  this.__data__ = [];
	  this.size = 0;
	}

	var _listCacheClear = listCacheClear$1;

	/**
	 * Performs a
	 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
	 * comparison between two values to determine if they are equivalent.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to compare.
	 * @param {*} other The other value to compare.
	 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
	 * @example
	 *
	 * var object = { 'a': 1 };
	 * var other = { 'a': 1 };
	 *
	 * _.eq(object, object);
	 * // => true
	 *
	 * _.eq(object, other);
	 * // => false
	 *
	 * _.eq('a', 'a');
	 * // => true
	 *
	 * _.eq('a', Object('a'));
	 * // => false
	 *
	 * _.eq(NaN, NaN);
	 * // => true
	 */

	function eq$2(value, other) {
	  return value === other || (value !== value && other !== other);
	}

	var eq_1 = eq$2;

	var eq$1 = eq_1;

	/**
	 * Gets the index at which the `key` is found in `array` of key-value pairs.
	 *
	 * @private
	 * @param {Array} array The array to inspect.
	 * @param {*} key The key to search for.
	 * @returns {number} Returns the index of the matched value, else `-1`.
	 */
	function assocIndexOf$4(array, key) {
	  var length = array.length;
	  while (length--) {
	    if (eq$1(array[length][0], key)) {
	      return length;
	    }
	  }
	  return -1;
	}

	var _assocIndexOf = assocIndexOf$4;

	var assocIndexOf$3 = _assocIndexOf;

	/** Used for built-in method references. */
	var arrayProto = Array.prototype;

	/** Built-in value references. */
	var splice = arrayProto.splice;

	/**
	 * Removes `key` and its value from the list cache.
	 *
	 * @private
	 * @name delete
	 * @memberOf ListCache
	 * @param {string} key The key of the value to remove.
	 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
	 */
	function listCacheDelete$1(key) {
	  var data = this.__data__,
	      index = assocIndexOf$3(data, key);

	  if (index < 0) {
	    return false;
	  }
	  var lastIndex = data.length - 1;
	  if (index == lastIndex) {
	    data.pop();
	  } else {
	    splice.call(data, index, 1);
	  }
	  --this.size;
	  return true;
	}

	var _listCacheDelete = listCacheDelete$1;

	var assocIndexOf$2 = _assocIndexOf;

	/**
	 * Gets the list cache value for `key`.
	 *
	 * @private
	 * @name get
	 * @memberOf ListCache
	 * @param {string} key The key of the value to get.
	 * @returns {*} Returns the entry value.
	 */
	function listCacheGet$1(key) {
	  var data = this.__data__,
	      index = assocIndexOf$2(data, key);

	  return index < 0 ? undefined : data[index][1];
	}

	var _listCacheGet = listCacheGet$1;

	var assocIndexOf$1 = _assocIndexOf;

	/**
	 * Checks if a list cache value for `key` exists.
	 *
	 * @private
	 * @name has
	 * @memberOf ListCache
	 * @param {string} key The key of the entry to check.
	 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
	 */
	function listCacheHas$1(key) {
	  return assocIndexOf$1(this.__data__, key) > -1;
	}

	var _listCacheHas = listCacheHas$1;

	var assocIndexOf = _assocIndexOf;

	/**
	 * Sets the list cache `key` to `value`.
	 *
	 * @private
	 * @name set
	 * @memberOf ListCache
	 * @param {string} key The key of the value to set.
	 * @param {*} value The value to set.
	 * @returns {Object} Returns the list cache instance.
	 */
	function listCacheSet$1(key, value) {
	  var data = this.__data__,
	      index = assocIndexOf(data, key);

	  if (index < 0) {
	    ++this.size;
	    data.push([key, value]);
	  } else {
	    data[index][1] = value;
	  }
	  return this;
	}

	var _listCacheSet = listCacheSet$1;

	var listCacheClear = _listCacheClear,
	    listCacheDelete = _listCacheDelete,
	    listCacheGet = _listCacheGet,
	    listCacheHas = _listCacheHas,
	    listCacheSet = _listCacheSet;

	/**
	 * Creates an list cache object.
	 *
	 * @private
	 * @constructor
	 * @param {Array} [entries] The key-value pairs to cache.
	 */
	function ListCache$1(entries) {
	  var index = -1,
	      length = entries == null ? 0 : entries.length;

	  this.clear();
	  while (++index < length) {
	    var entry = entries[index];
	    this.set(entry[0], entry[1]);
	  }
	}

	// Add methods to `ListCache`.
	ListCache$1.prototype.clear = listCacheClear;
	ListCache$1.prototype['delete'] = listCacheDelete;
	ListCache$1.prototype.get = listCacheGet;
	ListCache$1.prototype.has = listCacheHas;
	ListCache$1.prototype.set = listCacheSet;

	var _ListCache = ListCache$1;

	var getNative$1 = _getNative,
	    root = _root;

	/* Built-in method references that are verified to be native. */
	var Map$1 = getNative$1(root, 'Map');

	var _Map = Map$1;

	var Hash = _Hash,
	    ListCache = _ListCache,
	    Map = _Map;

	/**
	 * Removes all key-value entries from the map.
	 *
	 * @private
	 * @name clear
	 * @memberOf MapCache
	 */
	function mapCacheClear$1() {
	  this.size = 0;
	  this.__data__ = {
	    'hash': new Hash,
	    'map': new (Map || ListCache),
	    'string': new Hash
	  };
	}

	var _mapCacheClear = mapCacheClear$1;

	/**
	 * Checks if `value` is suitable for use as unique object key.
	 *
	 * @private
	 * @param {*} value The value to check.
	 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
	 */

	function isKeyable$1(value) {
	  var type = typeof value;
	  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
	    ? (value !== '__proto__')
	    : (value === null);
	}

	var _isKeyable = isKeyable$1;

	var isKeyable = _isKeyable;

	/**
	 * Gets the data for `map`.
	 *
	 * @private
	 * @param {Object} map The map to query.
	 * @param {string} key The reference key.
	 * @returns {*} Returns the map data.
	 */
	function getMapData$4(map, key) {
	  var data = map.__data__;
	  return isKeyable(key)
	    ? data[typeof key == 'string' ? 'string' : 'hash']
	    : data.map;
	}

	var _getMapData = getMapData$4;

	var getMapData$3 = _getMapData;

	/**
	 * Removes `key` and its value from the map.
	 *
	 * @private
	 * @name delete
	 * @memberOf MapCache
	 * @param {string} key The key of the value to remove.
	 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
	 */
	function mapCacheDelete$1(key) {
	  var result = getMapData$3(this, key)['delete'](key);
	  this.size -= result ? 1 : 0;
	  return result;
	}

	var _mapCacheDelete = mapCacheDelete$1;

	var getMapData$2 = _getMapData;

	/**
	 * Gets the map value for `key`.
	 *
	 * @private
	 * @name get
	 * @memberOf MapCache
	 * @param {string} key The key of the value to get.
	 * @returns {*} Returns the entry value.
	 */
	function mapCacheGet$1(key) {
	  return getMapData$2(this, key).get(key);
	}

	var _mapCacheGet = mapCacheGet$1;

	var getMapData$1 = _getMapData;

	/**
	 * Checks if a map value for `key` exists.
	 *
	 * @private
	 * @name has
	 * @memberOf MapCache
	 * @param {string} key The key of the entry to check.
	 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
	 */
	function mapCacheHas$1(key) {
	  return getMapData$1(this, key).has(key);
	}

	var _mapCacheHas = mapCacheHas$1;

	var getMapData = _getMapData;

	/**
	 * Sets the map `key` to `value`.
	 *
	 * @private
	 * @name set
	 * @memberOf MapCache
	 * @param {string} key The key of the value to set.
	 * @param {*} value The value to set.
	 * @returns {Object} Returns the map cache instance.
	 */
	function mapCacheSet$1(key, value) {
	  var data = getMapData(this, key),
	      size = data.size;

	  data.set(key, value);
	  this.size += data.size == size ? 0 : 1;
	  return this;
	}

	var _mapCacheSet = mapCacheSet$1;

	var mapCacheClear = _mapCacheClear,
	    mapCacheDelete = _mapCacheDelete,
	    mapCacheGet = _mapCacheGet,
	    mapCacheHas = _mapCacheHas,
	    mapCacheSet = _mapCacheSet;

	/**
	 * Creates a map cache object to store key-value pairs.
	 *
	 * @private
	 * @constructor
	 * @param {Array} [entries] The key-value pairs to cache.
	 */
	function MapCache$1(entries) {
	  var index = -1,
	      length = entries == null ? 0 : entries.length;

	  this.clear();
	  while (++index < length) {
	    var entry = entries[index];
	    this.set(entry[0], entry[1]);
	  }
	}

	// Add methods to `MapCache`.
	MapCache$1.prototype.clear = mapCacheClear;
	MapCache$1.prototype['delete'] = mapCacheDelete;
	MapCache$1.prototype.get = mapCacheGet;
	MapCache$1.prototype.has = mapCacheHas;
	MapCache$1.prototype.set = mapCacheSet;

	var _MapCache = MapCache$1;

	var MapCache = _MapCache;

	/** Error message constants. */
	var FUNC_ERROR_TEXT = 'Expected a function';

	/**
	 * Creates a function that memoizes the result of `func`. If `resolver` is
	 * provided, it determines the cache key for storing the result based on the
	 * arguments provided to the memoized function. By default, the first argument
	 * provided to the memoized function is used as the map cache key. The `func`
	 * is invoked with the `this` binding of the memoized function.
	 *
	 * **Note:** The cache is exposed as the `cache` property on the memoized
	 * function. Its creation may be customized by replacing the `_.memoize.Cache`
	 * constructor with one whose instances implement the
	 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
	 * method interface of `clear`, `delete`, `get`, `has`, and `set`.
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Function
	 * @param {Function} func The function to have its output memoized.
	 * @param {Function} [resolver] The function to resolve the cache key.
	 * @returns {Function} Returns the new memoized function.
	 * @example
	 *
	 * var object = { 'a': 1, 'b': 2 };
	 * var other = { 'c': 3, 'd': 4 };
	 *
	 * var values = _.memoize(_.values);
	 * values(object);
	 * // => [1, 2]
	 *
	 * values(other);
	 * // => [3, 4]
	 *
	 * object.a = 2;
	 * values(object);
	 * // => [1, 2]
	 *
	 * // Modify the result cache.
	 * values.cache.set(object, ['a', 'b']);
	 * values(object);
	 * // => ['a', 'b']
	 *
	 * // Replace `_.memoize.Cache`.
	 * _.memoize.Cache = WeakMap;
	 */
	function memoize$1(func, resolver) {
	  if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
	    throw new TypeError(FUNC_ERROR_TEXT);
	  }
	  var memoized = function() {
	    var args = arguments,
	        key = resolver ? resolver.apply(this, args) : args[0],
	        cache = memoized.cache;

	    if (cache.has(key)) {
	      return cache.get(key);
	    }
	    var result = func.apply(this, args);
	    memoized.cache = cache.set(key, result) || cache;
	    return result;
	  };
	  memoized.cache = new (memoize$1.Cache || MapCache);
	  return memoized;
	}

	// Expose `MapCache`.
	memoize$1.Cache = MapCache;

	var memoize_1 = memoize$1;

	var memoize = memoize_1;

	/** Used as the maximum memoize cache size. */
	var MAX_MEMOIZE_SIZE = 500;

	/**
	 * A specialized version of `_.memoize` which clears the memoized function's
	 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
	 *
	 * @private
	 * @param {Function} func The function to have its output memoized.
	 * @returns {Function} Returns the new memoized function.
	 */
	function memoizeCapped$1(func) {
	  var result = memoize(func, function(key) {
	    if (cache.size === MAX_MEMOIZE_SIZE) {
	      cache.clear();
	    }
	    return key;
	  });

	  var cache = result.cache;
	  return result;
	}

	var _memoizeCapped = memoizeCapped$1;

	var memoizeCapped = _memoizeCapped;

	/** Used to match property names within property paths. */
	var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

	/** Used to match backslashes in property paths. */
	var reEscapeChar = /\\(\\)?/g;

	/**
	 * Converts `string` to a property path array.
	 *
	 * @private
	 * @param {string} string The string to convert.
	 * @returns {Array} Returns the property path array.
	 */
	var stringToPath$1 = memoizeCapped(function(string) {
	  var result = [];
	  if (string.charCodeAt(0) === 46 /* . */) {
	    result.push('');
	  }
	  string.replace(rePropName, function(match, number, quote, subString) {
	    result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
	  });
	  return result;
	});

	var _stringToPath = stringToPath$1;

	/**
	 * A specialized version of `_.map` for arrays without support for iteratee
	 * shorthands.
	 *
	 * @private
	 * @param {Array} [array] The array to iterate over.
	 * @param {Function} iteratee The function invoked per iteration.
	 * @returns {Array} Returns the new mapped array.
	 */

	function arrayMap$1(array, iteratee) {
	  var index = -1,
	      length = array == null ? 0 : array.length,
	      result = Array(length);

	  while (++index < length) {
	    result[index] = iteratee(array[index], index, array);
	  }
	  return result;
	}

	var _arrayMap = arrayMap$1;

	var Symbol = _Symbol,
	    arrayMap = _arrayMap,
	    isArray$2 = isArray_1,
	    isSymbol$1 = isSymbol_1;

	/** Used as references for various `Number` constants. */
	var INFINITY$1 = 1 / 0;

	/** Used to convert symbols to primitives and strings. */
	var symbolProto = Symbol ? Symbol.prototype : undefined,
	    symbolToString = symbolProto ? symbolProto.toString : undefined;

	/**
	 * The base implementation of `_.toString` which doesn't convert nullish
	 * values to empty strings.
	 *
	 * @private
	 * @param {*} value The value to process.
	 * @returns {string} Returns the string.
	 */
	function baseToString$1(value) {
	  // Exit early for strings to avoid a performance hit in some environments.
	  if (typeof value == 'string') {
	    return value;
	  }
	  if (isArray$2(value)) {
	    // Recursively convert values (susceptible to call stack limits).
	    return arrayMap(value, baseToString$1) + '';
	  }
	  if (isSymbol$1(value)) {
	    return symbolToString ? symbolToString.call(value) : '';
	  }
	  var result = (value + '');
	  return (result == '0' && (1 / value) == -INFINITY$1) ? '-0' : result;
	}

	var _baseToString = baseToString$1;

	var baseToString = _baseToString;

	/**
	 * Converts `value` to a string. An empty string is returned for `null`
	 * and `undefined` values. The sign of `-0` is preserved.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Lang
	 * @param {*} value The value to convert.
	 * @returns {string} Returns the converted string.
	 * @example
	 *
	 * _.toString(null);
	 * // => ''
	 *
	 * _.toString(-0);
	 * // => '-0'
	 *
	 * _.toString([1, 2, 3]);
	 * // => '1,2,3'
	 */
	function toString$1(value) {
	  return value == null ? '' : baseToString(value);
	}

	var toString_1 = toString$1;

	var isArray$1 = isArray_1,
	    isKey = _isKey,
	    stringToPath = _stringToPath,
	    toString = toString_1;

	/**
	 * Casts `value` to a path array if it's not one.
	 *
	 * @private
	 * @param {*} value The value to inspect.
	 * @param {Object} [object] The object to query keys on.
	 * @returns {Array} Returns the cast property path array.
	 */
	function castPath$3(value, object) {
	  if (isArray$1(value)) {
	    return value;
	  }
	  return isKey(value, object) ? [value] : stringToPath(toString(value));
	}

	var _castPath = castPath$3;

	var isSymbol = isSymbol_1;

	/** Used as references for various `Number` constants. */
	var INFINITY = 1 / 0;

	/**
	 * Converts `value` to a string key if it's not a string or symbol.
	 *
	 * @private
	 * @param {*} value The value to inspect.
	 * @returns {string|symbol} Returns the key.
	 */
	function toKey$3(value) {
	  if (typeof value == 'string' || isSymbol(value)) {
	    return value;
	  }
	  var result = (value + '');
	  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
	}

	var _toKey = toKey$3;

	var castPath$2 = _castPath,
	    toKey$2 = _toKey;

	/**
	 * The base implementation of `_.get` without support for default values.
	 *
	 * @private
	 * @param {Object} object The object to query.
	 * @param {Array|string} path The path of the property to get.
	 * @returns {*} Returns the resolved value.
	 */
	function baseGet$2(object, path) {
	  path = castPath$2(path, object);

	  var index = 0,
	      length = path.length;

	  while (object != null && index < length) {
	    object = object[toKey$2(path[index++])];
	  }
	  return (index && index == length) ? object : undefined;
	}

	var _baseGet = baseGet$2;

	var baseGet$1 = _baseGet;

	/**
	 * Gets the value at `path` of `object`. If the resolved value is
	 * `undefined`, the `defaultValue` is returned in its place.
	 *
	 * @static
	 * @memberOf _
	 * @since 3.7.0
	 * @category Object
	 * @param {Object} object The object to query.
	 * @param {Array|string} path The path of the property to get.
	 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
	 * @returns {*} Returns the resolved value.
	 * @example
	 *
	 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
	 *
	 * _.get(object, 'a[0].b.c');
	 * // => 3
	 *
	 * _.get(object, ['a', '0', 'b', 'c']);
	 * // => 3
	 *
	 * _.get(object, 'a.b.c', 'default');
	 * // => 'default'
	 */
	function get(object, path, defaultValue) {
	  var result = object == null ? undefined : baseGet$1(object, path);
	  return result === undefined ? defaultValue : result;
	}

	var get_1 = get;

	var get$1 = /*@__PURE__*/getDefaultExportFromCjs(get_1);

	const EMAIL_REGEX = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	const URL_REGEX = /(http(s)?:\/\/.)?(www\.)?[-a-zA-Z0-9@:%._+~#=]{1,256}\.[a-z]{1,256}\b([-a-zA-Z0-9@:%_+.~#?&//=]*)/g;
	const objectConstructor = {}.constructor;
	const isString = param => {
	  return typeof param === 'string';
	};
	const isObject$1 = param => {
	  return param.constructor === objectConstructor;
	};
	const isJsx = param => {
	  return /*#__PURE__*/React.isValidElement(param);
	};
	const isValidNumber = param => {
	  return !isNaN(param);
	};
	const isFunction = functionToCheck => {
	  return functionToCheck && {}.toString.call(functionToCheck) === '[object Function]';
	};
	const isValidDate = date => {
	  return date && Object.prototype.toString.call(date) === '[object Date]' && !isNaN(date);
	};
	const isNullOrUndefined = param => {
	  const result = param === undefined || param === null;
	  return result;
	};
	const isEmptyString = param => {
	  const result = param === undefined || param === null || param === '';
	  return result;
	};
	const isValidEmail = param => {
	  return EMAIL_REGEX.test(String(param));
	};
	const isValidUrl = param => {
	  const result = param && param.match(URL_REGEX);
	  return !!result;
	};
	const isArray = param => {
	  return Array.isArray(param);
	};
	const isValidIban = param => {
	  let CODE_LENGTHS = {
	    AD: 24,
	    AE: 23,
	    AT: 20,
	    AZ: 28,
	    BA: 20,
	    BE: 16,
	    BG: 22,
	    BH: 22,
	    BR: 29,
	    CH: 21,
	    CY: 28,
	    CZ: 24,
	    DE: 22,
	    DK: 18,
	    DO: 28,
	    EE: 20,
	    ES: 24,
	    FI: 18,
	    FO: 18,
	    FR: 27,
	    GB: 22,
	    GI: 23,
	    GL: 18,
	    GR: 27,
	    GT: 28,
	    HR: 21,
	    HU: 28,
	    IE: 22,
	    IL: 23,
	    IS: 26,
	    IT: 27,
	    JO: 30,
	    KW: 30,
	    KZ: 20,
	    LB: 28,
	    LI: 21,
	    LT: 20,
	    LU: 20,
	    LV: 21,
	    MC: 27,
	    MD: 24,
	    ME: 22,
	    MK: 19,
	    MR: 27,
	    MT: 31,
	    MU: 30,
	    NL: 18,
	    NO: 15,
	    PK: 24,
	    PL: 28,
	    PS: 29,
	    PT: 25,
	    QA: 29,
	    RO: 24,
	    RS: 22,
	    SA: 24,
	    SE: 24,
	    SI: 19,
	    SK: 24,
	    SM: 27,
	    TN: 24,
	    TR: 26,
	    AL: 28,
	    BY: 28,
	    CR: 22,
	    EG: 29,
	    GE: 22,
	    IQ: 23,
	    LC: 32,
	    SC: 31,
	    ST: 25,
	    SV: 28,
	    TL: 23,
	    UA: 29,
	    VA: 22,
	    VG: 24,
	    XK: 20
	  };
	  let iban = String(param).toUpperCase().replace(/[^A-Z0-9]/g, ''),
	    // keep only alphanumeric characters
	    code = iban.match(/^([A-Z]{2})(\d{2})([A-Z\d]+)$/),
	    // match and capture (1) the country code, (2) the check digits, and (3) the rest
	    digits;
	  // check syntax and length
	  if (!code || iban.length !== CODE_LENGTHS[code[1]]) {
	    return false;
	  }
	  // rearrange country code and check digits, and convert chars to ints
	  digits = (code[3] + code[1] + code[2]).replace(/[A-Z]/g, function (letter) {
	    return letter.charCodeAt(0) - 55;
	  });
	  // final check
	  return mod97(digits);
	};
	const mod97 = string => {
	  let checksum = string.slice(0, 2),
	    fragment;
	  for (let offset = 2; offset < string.length; offset += 7) {
	    fragment = String(checksum) + string.substring(offset, offset + 7);
	    checksum = parseInt(fragment, 10) % 97;
	  }
	  return checksum;
	};
	const defaultEnFormatDate = date => {
	  let month = '' + (date.getMonth() + 1);
	  let day = '' + date.getDate();
	  let year = date.getFullYear();
	  if (month.length < 2) {
	    month = '0' + month;
	  }
	  if (day.length < 2) {
	    day = '0' + day;
	  }
	  const result = [month, day, year].join('/');
	  return result;
	};
	const defaultEnFormatDateWithTime = date => {
	  let month = '' + (date.getMonth() + 1);
	  let day = '' + date.getDate();
	  let year = date.getFullYear();
	  let hours = '' + date.getHours();
	  let minutes = '' + date.getMinutes();
	  if (month.length < 2) {
	    month = '0' + month;
	  }
	  if (day.length < 2) {
	    day = '0' + day;
	  }
	  if (hours.length < 2) {
	    hours = '0' + hours;
	  }
	  if (minutes.length < 2) {
	    minutes = '0' + minutes;
	  }
	  let result = [month, day, year].join('/');
	  result += ' ' + hours + ':' + minutes;
	  return result;
	};
	const defaultTrFormatDate = date => {
	  let month = '' + (date.getMonth() + 1);
	  let day = '' + date.getDate();
	  let year = date.getFullYear();
	  if (month.length < 2) {
	    month = '0' + month;
	  }
	  if (day.length < 2) {
	    day = '0' + day;
	  }
	  const result = [day, month, year].join('.');
	  return result;
	};
	const defaultTrFormatDateWithTime = date => {
	  let month = '' + (date.getMonth() + 1);
	  let day = '' + date.getDate();
	  let year = date.getFullYear();
	  let hours = '' + date.getHours();
	  let minutes = '' + date.getMinutes();
	  if (month.length < 2) {
	    month = '0' + month;
	  }
	  if (day.length < 2) {
	    day = '0' + day;
	  }
	  if (hours.length < 2) {
	    hours = '0' + hours;
	  }
	  if (minutes.length < 2) {
	    minutes = '0' + minutes;
	  }
	  let result = [day, month, year].join('.');
	  result += ' ' + hours + ':' + minutes;
	  return result;
	};

	const COMPARISON_KEYS = ['equalTo', 'lessThan', 'lessThanOrEqualTo', 'greaterThan', 'greaterThanOrEqualTo', 'notEqualTo'];
	const isEmptyStringOrArray = value => {
	  if (isArray(value)) {
	    return value.length < 1;
	  }
	  return isEmptyString(value);
	};
	const handleValidationsOfForm = validationParams => {
	  const {
	    rules,
	    formData,
	    context,
	    currentValidationError,
	    pathToBeRun
	  } = validationParams;
	  let validationErrorOriginalResult = {};
	  if (rules) {
	    if (!isArray(rules)) {
	      throw new Error(`useValidatableForm error. "rules" should be an array`);
	    }
	    let rulesToBeRun = [];
	    if (pathToBeRun) {
	      const originalStr = pathToBeRun;
	      let resultStr = pathToBeRun;
	      if (resultStr.includes('[')) {
	        resultStr = resultStr.substring(0, resultStr.indexOf('['));
	      }
	      validationErrorOriginalResult = {
	        ...currentValidationError
	      };
	      rulesToBeRun = rules.filter(r => {
	        return !!(resultStr === r.path || originalStr === r.path || resultStr === r.listPath || originalStr === r.listPath || r.dependantPaths && r.dependantPaths.includes(resultStr) || r.dependantPaths && r.dependantPaths.includes(originalStr));
	      });
	      const keysToBeDeleted = Object.keys(validationErrorOriginalResult).filter(kp => {
	        return kp === resultStr || kp.startsWith(resultStr + '{');
	      });
	      keysToBeDeleted.forEach(kd => {
	        delete validationErrorOriginalResult[kd];
	      });
	    } else {
	      validationErrorOriginalResult = {};
	      rulesToBeRun = rules;
	    }
	    rulesToBeRun.forEach(ruleDef => {
	      const path = ruleDef.path;
	      const listPath = ruleDef.listPath;
	      const dependantPaths = ruleDef.dependantPaths;
	      const subRules = ruleDef.subRules;
	      if (!path && !listPath) {
	        throw new Error(`useValidatableForm error. Either "path" or "listPath" keys should exist in validation definitions`);
	      }
	      if (listPath && path) {
	        throw new Error(`useValidatableForm error. Only one of "path" or "listPath" keys should exist in validation definitions`);
	      }
	      if (dependantPaths && !isArray(dependantPaths)) {
	        throw new Error(`useValidatableForm error. "dependantPaths" key should be an array`);
	      }
	      const ruleSetOfKey = ruleDef.ruleSet;
	      if (!listPath && !ruleSetOfKey) {
	        throw new Error(`useValidatableForm error. "ruleSet" key should exist in validation definitions if "path" is the key`);
	      }
	      if (listPath && !ruleSetOfKey && !subRules) {
	        throw new Error(`useValidatableForm error. One of "ruleSet" or "subRules" keys should exist in validation definitions if "listPath" is the key`);
	      }
	      if (subRules && ruleSetOfKey) {
	        throw new Error(`useValidatableForm error. Only one of "ruleSet" or "subRules" keys should exist in validation definitions`);
	      }
	      if (path && !isString(path)) {
	        throw new Error(`useValidatableForm error. "path" key should be a string`);
	      }
	      if (listPath && !isString(listPath)) {
	        throw new Error(`useValidatableForm error. "listPath" key should be a string`);
	      }
	      let valuesToBeValidated = [];
	      if (listPath) {
	        if (subRules) {
	          if (!isArray(subRules)) {
	            throw new Error(`useValidatableForm error. "subRules" param should be an array`);
	          }
	          for (const subRule of subRules) {
	            const subRulePath = subRule.path;
	            const subRuleSet = subRule.ruleSet;
	            const listObject = get$1(formData, listPath);
	            if (listObject && listObject.length > 0) {
	              for (let k = 0; k < listObject.length; k++) {
	                const validatableObject = {
	                  value: get$1(listObject[k], subRulePath),
	                  fullPath: `${listPath}{${k}}.${subRulePath}`,
	                  subRuleSet: subRuleSet,
	                  indexOfList: k,
	                  subRulePath: subRulePath
	                };
	                valuesToBeValidated.push(validatableObject);
	              }
	            }
	          }
	        } else {
	          const listObject = get$1(formData, listPath);
	          if (listObject && listObject.length > 0) {
	            for (let k = 0; k < listObject.length; k++) {
	              const validatableObject = {
	                value: listObject[k],
	                fullPath: `${listPath}{${k}}`,
	                subRuleSet: ruleSetOfKey,
	                indexOfList: k
	              };
	              valuesToBeValidated.push(validatableObject);
	            }
	          }
	        }
	      } else {
	        const validatableObject = {
	          value: get$1(formData, path),
	          fullPath: path,
	          subRuleSet: ruleSetOfKey
	        };
	        valuesToBeValidated.push(validatableObject);
	      }
	      if (valuesToBeValidated.length > 0) {
	        for (const valueToBeValidated of valuesToBeValidated) {
	          const subRuleSet = valueToBeValidated.subRuleSet;
	          for (const ruleInfo of subRuleSet) {
	            let rule = null;
	            let options = {};
	            if (isString(ruleInfo)) {
	              rule = ruleInfo;
	              options = {};
	            } else {
	              const {
	                rule: ruleName,
	                ...optionsOfRule
	              } = ruleInfo;
	              rule = ruleName;
	              options = optionsOfRule;
	            }
	            if (!rule) {
	              if (path) {
	                throw new Error(`useValidatableForm error. "rule" key should exist in validation definitions object of path: ${path}`);
	              } else {
	                throw new Error(`useValidatableForm error. "rule" key should exist in validation definitions object of listPath: ${listPath}`);
	              }
	            }
	            if (rule === 'unique' && !listPath) {
	              throw new Error(`useValidatableForm error. Rule "unique" can only be used with "listPath"`);
	            }
	            let ruleFunction = null;
	            if (isFunction(rule)) {
	              ruleFunction = rule;
	            } else {
	              ruleFunction = context.allRules[rule];
	            }
	            if (!ruleFunction) {
	              throw new Error(`useValidatableForm error. rule "${rule}" is not defined`);
	            }
	            const validatorFunction = VALIDATOR_FUNCTION_MAP[rule];
	            const value = valueToBeValidated.value;
	            const fullPath = valueToBeValidated.fullPath;
	            const indexOfList = valueToBeValidated.indexOfList;
	            const subRulePath = valueToBeValidated.subRulePath;
	            delete validationErrorOriginalResult[fullPath];
	            const ruleParams = {
	              value,
	              context,
	              formData,
	              path: fullPath,
	              options,
	              currentRule: rule,
	              validatorFunction,
	              indexOfList,
	              originalListPath: listPath,
	              subRulePath
	            };
	            const isEnabled = handleIsValidationEnabled(ruleParams);
	            if (isEnabled) {
	              const resultErrorMessageParams = ruleFunction(ruleParams);
	              if (resultErrorMessageParams) {
	                let validationErrorResult = null;
	                if (isString(resultErrorMessageParams) || isJsx(resultErrorMessageParams)) {
	                  validationErrorResult = resultErrorMessageParams;
	                } else if (isObject$1(resultErrorMessageParams)) {
	                  resultErrorMessageParams.context = context;
	                  resultErrorMessageParams.rule = rule;
	                  resultErrorMessageParams.options = options;
	                  resultErrorMessageParams.indexOfList = indexOfList;
	                  resultErrorMessageParams.formData = formData;
	                  if (resultErrorMessageParams.isCommonError) {
	                    validationErrorResult = getCommonErrorMessageByKey(resultErrorMessageParams);
	                  } else {
	                    validationErrorResult = getErrorMessage(resultErrorMessageParams);
	                  }
	                } else {
	                  throw new Error(`useValidatableForm error. Validation result should be either string or json on rule "${rule}" of path: ${path}. Current result: ${resultErrorMessageParams}`);
	                }
	                validationErrorOriginalResult[fullPath] = validationErrorResult;
	                break;
	              }
	            }
	          }
	        }
	      }
	    });
	  }
	  return validationErrorOriginalResult;
	};
	const handleIsValidationEnabled = ruleParams => {
	  const {
	    formData,
	    indexOfList,
	    options
	  } = ruleParams;
	  const {
	    disableIf,
	    enableIf
	  } = options;
	  if (disableIf && !isFunction(disableIf)) {
	    throw new Error(`useValidatableForm error. "disableIf" property should be a function`);
	  }
	  if (enableIf && !isFunction(enableIf)) {
	    throw new Error(`useValidatableForm error. "enableIf" property should be a function`);
	  }
	  let isDisabled = false;
	  let isEnabled = true;
	  if (disableIf) {
	    isDisabled = disableIf(formData, indexOfList);
	  }
	  if (enableIf) {
	    isEnabled = enableIf(formData, indexOfList);
	  }
	  const result = !isDisabled && isEnabled;
	  return result;
	};
	const handleRequired = ruleParams => {
	  const {
	    value
	  } = ruleParams;
	  if (isEmptyStringOrArray(value)) {
	    const errorMessageParams = {
	      value
	    };
	    return errorMessageParams;
	  }
	  return null;
	};
	const handleGeneralComparison = ruleParams => {
	  const {
	    context,
	    path,
	    options,
	    currentRule,
	    formData,
	    value,
	    indexOfList
	  } = ruleParams;
	  if (isEmptyStringOrArray(value) && !options.applyToNulls) {
	    return null;
	  }
	  let comparisonKey = null;
	  for (const candidateKey of COMPARISON_KEYS) {
	    const canditateValue = options[candidateKey];
	    if (!isEmptyString(canditateValue)) {
	      comparisonKey = candidateKey;
	      break;
	    }
	  }
	  let valueToBeCompared = value;
	  if (currentRule === 'number') {
	    valueToBeCompared = isEmptyString(value) ? undefined : Number(value);
	  } else if (currentRule === 'length' || currentRule === 'listSize') {
	    valueToBeCompared = value && value.length ? value.length : 0;
	  }
	  if (currentRule === 'number') {
	    if (!isValidNumber(valueToBeCompared)) {
	      const errorMessageParams = {
	        messageKey: 'valueIsNotAValidNumber',
	        isCommonError: true
	      };
	      return errorMessageParams;
	    }
	    if (options.onlyIntegers) {
	      if (!Number.isInteger(valueToBeCompared)) {
	        const errorMessageParams = {
	          messageKey: 'valueIsNotAnInteger',
	          isCommonError: true
	        };
	        return errorMessageParams;
	      }
	    }
	  }
	  if (currentRule === 'date') {
	    if (!isValidDate(valueToBeCompared)) {
	      const errorMessageParams = {
	        messageKey: 'valueIsNotAValidDate',
	        isCommonError: true
	      };
	      return errorMessageParams;
	    }
	  }
	  if (!comparisonKey) {
	    if (currentRule === 'date') {
	      return null;
	    }
	    if (currentRule === 'number') {
	      return null;
	    }
	    throw new Error(`useValidatableForm error. comparison key is not found on rule "${currentRule}" of path: ${path}`);
	  }
	  let comparisonValue = null;
	  if (isFunction(options[comparisonKey])) {
	    const comparisonFunction = options[comparisonKey];
	    comparisonValue = comparisonFunction(formData, indexOfList);
	  } else {
	    comparisonValue = options[comparisonKey];
	  }
	  if (isEmptyString(comparisonValue)) {
	    const errorMessageParams = {
	      messageKey: 'comparisonValueNotFound',
	      isCommonError: true
	    };
	    return errorMessageParams;
	  }
	  let currentValue = null;
	  let targetValue = null;
	  if (currentRule === 'date') {
	    if (!isValidDate(comparisonValue)) {
	      const errorMessageParams = {
	        messageKey: 'comparisonValueIsNotAValidDate',
	        isCommonError: true
	      };
	      return errorMessageParams;
	    }
	    if (options.withTime) {
	      currentValue = Date.UTC(valueToBeCompared.getFullYear(), valueToBeCompared.getMonth(), valueToBeCompared.getDate(), valueToBeCompared.getHours(), valueToBeCompared.getMinutes());
	      targetValue = Date.UTC(comparisonValue.getFullYear(), comparisonValue.getMonth(), comparisonValue.getDate(), comparisonValue.getHours(), comparisonValue.getMinutes());
	    } else {
	      currentValue = Date.UTC(valueToBeCompared.getFullYear(), valueToBeCompared.getMonth(), valueToBeCompared.getDate());
	      targetValue = Date.UTC(comparisonValue.getFullYear(), comparisonValue.getMonth(), comparisonValue.getDate());
	    }
	  } else {
	    currentValue = valueToBeCompared;
	    targetValue = Number(comparisonValue);
	    if (!isValidNumber(targetValue)) {
	      const errorMessageParams = {
	        messageKey: 'comparisonValueIsNotAValidNumber',
	        isCommonError: true
	      };
	      return errorMessageParams;
	    }
	  }
	  const compareParams = {
	    context,
	    currentValue,
	    targetValue,
	    comparisonKey,
	    rule: currentRule
	  };
	  const comparisonValidationResult = compareValuesAccordingToKey(compareParams);
	  if (isString(comparisonValidationResult)) {
	    return comparisonValidationResult;
	  }
	  let errorMessageValue = currentValue;
	  let errorMessageComparisonValue = comparisonValue;
	  if (currentRule === 'date') {
	    const defaultFormatDate = context.lang === 'tr' ? defaultTrFormatDate : defaultEnFormatDate;
	    const defaultFormatDateWithTime = context.lang === 'tr' ? defaultTrFormatDateWithTime : defaultEnFormatDateWithTime;
	    const defaultFormatterFunction = options.withTime ? defaultFormatDateWithTime : defaultFormatDate;
	    const contextDateFormatFunction = options.withTime ? context.dateWithTimeFormatterFunction : context.dateFormatterFunction;
	    const dateFormatFunction = contextDateFormatFunction || defaultFormatterFunction;
	    const currentDateValue = new Date(currentValue);
	    errorMessageValue = dateFormatFunction(currentDateValue);
	    const comparisonDateValue = new Date(comparisonValue);
	    errorMessageComparisonValue = dateFormatFunction(comparisonDateValue);
	  }
	  if (!comparisonValidationResult) {
	    const errorMessageParams = {
	      value: errorMessageValue,
	      comparisonValue: errorMessageComparisonValue,
	      comparisonKey
	    };
	    return errorMessageParams;
	  }
	  return null;
	};
	const handleStringControl = ruleParams => {
	  const {
	    options,
	    value,
	    validatorFunction
	  } = ruleParams;
	  if (isEmptyStringOrArray(value) && !options.applyToNulls) {
	    return null;
	  }
	  if (!validatorFunction(value)) {
	    const errorMessageParams = {
	      value
	    };
	    return errorMessageParams;
	  }
	  return null;
	};
	const handleEqualityControl = ruleParams => {
	  const {
	    formData,
	    options,
	    currentRule,
	    value,
	    path,
	    indexOfList
	  } = ruleParams;
	  if (isEmptyStringOrArray(value) && !options.applyToNulls) {
	    return null;
	  }
	  const {
	    equalTo,
	    notEqualTo,
	    isOneOf,
	    isNoneOf
	  } = options;
	  if (!equalTo && !isOneOf && !notEqualTo && !isNoneOf) {
	    throw new Error(`useValidatableForm error. equalTo, isOneOf, notEqualTo or isNoneOf keys is not found on rule "${currentRule}" of path: ${path}`);
	  } else if ((equalTo || notEqualTo) && (isOneOf || isNoneOf)) {
	    throw new Error(`useValidatableForm error. equalTo or notEqualTo and isOneOf or isNoneOf keys cannot be combined on rule "${currentRule} of path: ${path}`);
	  }
	  let comparisonValue = null;
	  if (equalTo) {
	    if (isFunction(equalTo)) {
	      comparisonValue = equalTo(formData, indexOfList);
	    } else {
	      comparisonValue = equalTo;
	    }
	    if (comparisonValue !== value) {
	      const errorMessageParams = {
	        value,
	        comparisonValue
	      };
	      return errorMessageParams;
	    }
	  } else if (isOneOf) {
	    if (isFunction(isOneOf)) {
	      comparisonValue = isOneOf(formData, indexOfList);
	    } else {
	      comparisonValue = isOneOf;
	    }
	    if (!isArray(comparisonValue)) {
	      throw new Error(`useValidatableForm error. isOneOf must be array on rule "${currentRule} of path: ${path}`);
	    }
	    if (!comparisonValue.includes(value)) {
	      const errorMessageParams = {
	        value,
	        comparisonValue
	      };
	      return errorMessageParams;
	    }
	  } else if (notEqualTo) {
	    if (isFunction(notEqualTo)) {
	      comparisonValue = notEqualTo(formData, indexOfList);
	    } else {
	      comparisonValue = notEqualTo;
	    }
	    if (comparisonValue === value) {
	      const errorMessageParams = {
	        value,
	        comparisonValue
	      };
	      return errorMessageParams;
	    }
	  } else if (isNoneOf) {
	    if (isFunction(isNoneOf)) {
	      comparisonValue = isNoneOf(formData, indexOfList);
	    } else {
	      comparisonValue = isNoneOf;
	    }
	    if (!isArray(comparisonValue)) {
	      throw new Error(`useValidatableForm error. isNoneOf must be array on rule "${currentRule} of path: ${path}`);
	    }
	    if (comparisonValue.includes(value)) {
	      const errorMessageParams = {
	        value,
	        comparisonValue
	      };
	      return errorMessageParams;
	    }
	  }
	  return null;
	};
	const handleIncludesControl = ruleParams => {
	  const {
	    formData,
	    options,
	    currentRule,
	    value,
	    path,
	    indexOfList
	  } = ruleParams;
	  if (isEmptyStringOrArray(value) && !options.applyToNulls) {
	    return null;
	  }
	  const {
	    includes
	  } = options;
	  if (!includes) {
	    throw new Error(`useValidatableForm error. includes key is not found on rule "${currentRule}" of path: ${path}`);
	  }
	  let comparisonValue = null;
	  if (isFunction(includes)) {
	    comparisonValue = includes(formData, indexOfList);
	  } else {
	    comparisonValue = includes;
	  }
	  if (!comparisonValue) {
	    const errorMessageParams = {
	      messageKey: 'comparisonValueNotFound',
	      isCommonError: true
	    };
	    return errorMessageParams;
	  }
	  let valueToCompare = value;
	  if (isNullOrUndefined(valueToCompare)) {
	    valueToCompare = '';
	  }
	  if (!isString(valueToCompare)) {
	    valueToCompare = value.toString();
	  }
	  if (!isString(comparisonValue)) {
	    throw new Error(`useValidatableForm error. comparisonValue is not string on rule "${currentRule}" of path: ${path}`);
	  }
	  if (!valueToCompare.includes(comparisonValue)) {
	    const errorMessageParams = {
	      value: valueToCompare,
	      comparisonValue
	    };
	    return errorMessageParams;
	  }
	  return null;
	};
	const handleRegexControl = ruleParams => {
	  const {
	    options,
	    currentRule,
	    value,
	    path
	  } = ruleParams;
	  if (isEmptyStringOrArray(value) && !options.applyToNulls) {
	    return null;
	  }
	  const {
	    regex
	  } = options;
	  if (!regex) {
	    throw new Error(`useValidatableForm error. regex key is not found on rule "${currentRule}" of path: ${path}`);
	  }
	  let regexObject = null;
	  try {
	    regexObject = new RegExp(regex);
	  } catch (e) {
	    throw new Error(`useValidatableForm error. regex param is not valid on rule "${currentRule}" of path: ${path}`);
	  }
	  if (!regexObject.test(value)) {
	    const errorMessageParams = {
	      value
	    };
	    return errorMessageParams;
	  }
	  return null;
	};
	const handleUniqueControl = ruleParams => {
	  const {
	    formData,
	    options,
	    value,
	    indexOfList,
	    originalListPath,
	    subRulePath
	  } = ruleParams;
	  if (isEmptyStringOrArray(value) && !options.applyToNulls) {
	    return null;
	  }
	  const fullList = get$1(formData, originalListPath);
	  const valueExistsInList = fullList && fullList.filter((el, ind) => {
	    let valueIsEqual = false;
	    if (subRulePath) {
	      valueIsEqual = get$1(el, subRulePath) === value;
	    } else {
	      valueIsEqual = el === value;
	    }
	    return valueIsEqual && indexOfList !== ind;
	  }).length > 0;
	  if (valueExistsInList) {
	    const errorMessageParams = {
	      value
	    };
	    return errorMessageParams;
	  }
	  return null;
	};
	const getCommonErrorMessageByKey = errorMessageParams => {
	  const {
	    context,
	    messageKey
	  } = errorMessageParams;
	  const {
	    lang,
	    translations
	  } = context;
	  const defaultMessage = translations[lang][messageKey];
	  let messageToBeReturned = defaultMessage;
	  if (!defaultMessage) {
	    messageToBeReturned = translations[DEFAULT_LANG][messageKey]; // fallback default to en
	  }

	  return messageToBeReturned;
	};
	const getErrorMessage = errorMessageParams => {
	  const {
	    context,
	    value,
	    comparisonValue,
	    comparisonKey,
	    rule,
	    options
	  } = errorMessageParams;
	  const {
	    lang,
	    translations
	  } = context;
	  let messageKey = `${rule}`;
	  if (comparisonKey) {
	    messageKey = `${rule}.${comparisonKey}`;
	  }
	  const defaultMessage = translations[lang][messageKey];
	  const customMessage = options && options.customMessage;
	  let messageToBeReturned = defaultMessage;
	  if (!defaultMessage) {
	    messageToBeReturned = translations[DEFAULT_LANG][messageKey]; // fallback default to en
	  }

	  if (customMessage) {
	    if (isString(customMessage) || isJsx(customMessage)) {
	      messageToBeReturned = customMessage;
	    } else if (isFunction(customMessage)) {
	      messageToBeReturned = customMessage(errorMessageParams);
	      if (!messageToBeReturned || !isString(messageToBeReturned) && !isJsx(messageToBeReturned)) {
	        throw new Error(`useValidatableForm error. "customMessage" function should return a valid string or jsx. currentValue: ${messageToBeReturned}`);
	      }
	    } else {
	      throw new Error(`useValidatableForm error. "customMessage" should be either of type string or function`);
	    }
	  }
	  if (!messageToBeReturned) {
	    throw new Error(`useValidatableForm error. Validation result could not be found while validating rule "${rule}" on value ${value}`);
	  }
	  if (isString(messageToBeReturned)) {
	    messageToBeReturned = messageToBeReturned.split('${value}').join(value);
	    messageToBeReturned = messageToBeReturned.split('${comparisonValue}').join(comparisonValue);
	  }
	  return messageToBeReturned;
	};
	const compareValuesAccordingToKey = compareParams => {
	  const {
	    currentValue,
	    targetValue,
	    comparisonKey
	  } = compareParams;
	  switch (comparisonKey) {
	    case 'equalTo':
	      return currentValue === targetValue;
	    case 'greaterThanOrEqualTo':
	      return currentValue >= targetValue;
	    case 'lessThanOrEqualTo':
	      return currentValue <= targetValue;
	    case 'greaterThan':
	      return currentValue > targetValue;
	    case 'lessThan':
	      return currentValue < targetValue;
	    case 'notEqualTo':
	      return currentValue !== targetValue;
	  }
	  return false;
	};
	const VALIDATOR_FUNCTION_MAP = {
	  email: isValidEmail,
	  url: isValidUrl,
	  iban: isValidIban
	};
	const VALIDATION_OPERATIONS_MAP = {
	  required: handleRequired,
	  number: handleGeneralComparison,
	  length: handleGeneralComparison,
	  listSize: handleGeneralComparison,
	  date: handleGeneralComparison,
	  email: handleStringControl,
	  url: handleStringControl,
	  iban: handleStringControl,
	  equality: handleEqualityControl,
	  includes: handleIncludesControl,
	  regex: handleRegexControl,
	  unique: handleUniqueControl
	};

	const ReactValidatableFormContext = /*#__PURE__*/React.createContext();

	const en = {
	  comparisonValueNotFound: 'Comparison value could not be found',
	  valueIsNotAValidNumber: 'Value is not a valid number',
	  valueIsNotAnInteger: 'Value is not an integer',
	  valueIsNotAValidDate: 'Value is not a valid date',
	  comparisonValueIsNotAValidNumber: 'Comparison value is not a valid number',
	  comparisonValueIsNotAValidDate: 'Comparison value is not a valid date',
	  required: 'This field is required',
	  email: 'Not a valid email',
	  url: 'Not a valid url',
	  iban: 'Not a valid IBAN',
	  equality: 'Not a valid value',
	  includes: 'Value should include "${comparisonValue}"',
	  regex: 'Not a valid value',
	  unique: 'Not a unique value',
	  'number.equalTo': 'Value should be equal to ${comparisonValue}',
	  'number.lessThan': 'Value should be less than ${comparisonValue}',
	  'number.lessThanOrEqualTo': 'Value should be less than or equal to ${comparisonValue}',
	  'number.greaterThan': 'Value should be greater than ${comparisonValue}',
	  'number.greaterThanOrEqualTo': 'Value should be greater than or equal to ${comparisonValue}',
	  'number.notEqualTo': 'Value should not be equal to ${comparisonValue}',
	  'length.equalTo': 'This field should have ${comparisonValue} characters',
	  'length.lessThan': 'This field should have less than ${comparisonValue} characters',
	  'length.lessThanOrEqualTo': 'This field should have less than or equal to ${comparisonValue} characters',
	  'length.greaterThan': 'This field should have more than ${comparisonValue} characters',
	  'length.greaterThanOrEqualTo': 'This field should have greater than or equal to ${comparisonValue} characters',
	  'length.notEqualTo': 'This field should not have ${comparisonValue} characters',
	  'listSize.equalTo': 'This field should consist of ${comparisonValue} elements',
	  'listSize.lessThan': 'This field should have less than ${comparisonValue} elements',
	  'listSize.lessThanOrEqualTo': 'This field should have less than or equal to ${comparisonValue} elements',
	  'listSize.greaterThan': 'This field should have more than ${comparisonValue} elements',
	  'listSize.greaterThanOrEqualTo': 'This field should have greater than or equal to ${comparisonValue} elements',
	  'listSize.notEqualTo': 'This field should not have ${comparisonValue} elements',
	  'date.equalTo': 'Date should be equal to ${comparisonValue}',
	  'date.lessThan': 'Date should be before ${comparisonValue}',
	  'date.lessThanOrEqualTo': 'Date should be before or equal to ${comparisonValue}',
	  'date.greaterThan': 'Date should be after ${comparisonValue}',
	  'date.greaterThanOrEqualTo': 'Date should be after or equal to ${comparisonValue}',
	  'date.notEqualTo': 'Date should not be equal to ${comparisonValue}'
	};

	const tr = {
	  comparisonValueNotFound: 'Kıyas yapılacak değer bulunamadı',
	  valueIsNotAValidNumber: 'Girilen değer geçerli bir sayı değil',
	  valueIsNotAnInteger: 'Girilen değer bir tam sayı değil',
	  valueIsNotAValidDate: 'Girilen değer geçerli bir tarih değil',
	  comparisonValueIsNotAValidNumber: 'Kıyas yapılacak değer geçerli bir sayı değil',
	  comparisonValueIsNotAValidDate: 'Kıyas yapılacak değer geçerli bir tarih değil',
	  required: 'Bu alan zorunludur',
	  email: 'Geçerli bir email değil',
	  url: 'Geçerli bir web adresi değil',
	  iban: 'Geçerli bir IBAN değil',
	  equality: 'Geçerli bir değer değil',
	  includes: 'Girilen değer "${comparisonValue}" değerini içermelidir',
	  regex: 'Geçerli bir değer değil',
	  unique: 'Benzersiz bir değer değil',
	  'number.equalTo': 'Girilen değer ${comparisonValue} değerine eşit olmalıdır',
	  'number.lessThan': 'Girilen değer ${comparisonValue} değerinden küçük olmalıdır',
	  'number.lessThanOrEqualTo': 'Girilen değer ${comparisonValue} veya daha küçük bir değere eşit olmalıdır',
	  'number.greaterThan': 'Girilen değer ${comparisonValue} değerinden büyük olmalıdır',
	  'number.greaterThanOrEqualTo': 'Girilen değer ${comparisonValue} veya daha büyük bir değere eşit olmalıdır',
	  'number.notEqualTo': 'Girilen değer ${comparisonValue} değerinden farklı olmalıdır',
	  'length.equalTo': 'Bu alan ${comparisonValue} karakterden oluşmalıdır',
	  'length.lessThan': 'Bu alan ${comparisonValue} değerinden daha az karakterden oluşmalıdır',
	  'length.lessThanOrEqualTo': 'Bu alan ${comparisonValue} veya daha az karakterden oluşmalıdır',
	  'length.greaterThan': 'Bu alan ${comparisonValue} değerinden daha fazla karakterden oluşmalıdır',
	  'length.greaterThanOrEqualTo': 'Bu alan ${comparisonValue} veya daha fazla karakterden oluşmalıdır',
	  'length.notEqualTo': 'Bu alan ${comparisonValue} karakterden oluşmamalıdır',
	  'listSize.equalTo': 'Bu alan ${comparisonValue} elemandan oluşmalıdır',
	  'listSize.lessThan': 'Bu alan ${comparisonValue} değerinden daha az elemandan oluşmalıdır',
	  'listSize.lessThanOrEqualTo': 'Bu alan ${comparisonValue} veya daha az elemandan oluşmalıdır',
	  'listSize.greaterThan': 'Bu alan ${comparisonValue} değerinden daha fazla elemandan oluşmalıdır',
	  'listSize.greaterThanOrEqualTo': 'Bu alan ${comparisonValue} veya daha fazla elemandan oluşmalıdır',
	  'listSize.notEqualTo': 'Bu alan ${comparisonValue} elemandan oluşmamalıdır',
	  'date.equalTo': 'Girilen tarih ${comparisonValue} tarihine eşit olmalıdır',
	  'date.lessThan': 'Girilen tarih ${comparisonValue} tarihinden önce olmalıdır',
	  'date.lessThanOrEqualTo': 'Girilen tarih ${comparisonValue} veya daha önce olmalıdır',
	  'date.greaterThan': 'Girilen tarih ${comparisonValue} tarihinden sonra olmalıdır',
	  'date.greaterThanOrEqualTo': 'Girilen tarih ${comparisonValue} veya daha sonra olmalıdır',
	  'date.notEqualTo': 'Girilen tarih ${comparisonValue} tarihinden farklı olmalıdır'
	};

	const translations = {
	  en: {
	    ...en
	  },
	  tr: {
	    ...tr
	  }
	};

	const ReactValidatableFormProvider = props => {
	  const {
	    customRules,
	    lang,
	    translations: translations$1,
	    dateFormatterFunction,
	    dateWithTimeFormatterFunction,
	    hideBeforeSubmit,
	    showAfterBlur,
	    focusToErrorAfterSubmit,
	    elementFocusHandler
	  } = props;
	  const contextValue = {
	    lang: DEFAULT_LANG
	  };
	  let allRules = {
	    ...VALIDATION_OPERATIONS_MAP
	  };
	  if (customRules) {
	    const baseRuleKeys = Object.keys(VALIDATION_OPERATIONS_MAP);
	    Object.keys(customRules).forEach(cr => {
	      if (baseRuleKeys.includes(cr)) {
	        throw new Error(`ReactValidatableFormProvider error. rule key: "${cr}" is already defined. Please rename custom rule key parameter of ReactValidatableFormProvider.`);
	      }
	    });
	    allRules = {
	      ...allRules,
	      ...customRules
	    };
	  }
	  contextValue.allRules = allRules;
	  contextValue.translations = JSON.parse(JSON.stringify(translations));
	  if (translations$1) {
	    Object.keys(translations$1).forEach(langKey => {
	      if (!contextValue.translations[langKey]) {
	        contextValue.translations[langKey] = {};
	      }
	      contextValue.translations[langKey] = {
	        ...contextValue.translations[langKey],
	        ...translations$1[langKey]
	      };
	    });
	  }
	  if (lang) {
	    if (!Object.keys(contextValue.translations).includes(lang)) {
	      throw `ReactValidatableFormProvider error. lang: "${lang}" is not found on translations.`;
	    }
	    contextValue.lang = lang;
	  }
	  contextValue.dateFormatterFunction = dateFormatterFunction;
	  contextValue.dateWithTimeFormatterFunction = dateWithTimeFormatterFunction;
	  contextValue.hideBeforeSubmit = hideBeforeSubmit;
	  contextValue.showAfterBlur = showAfterBlur;
	  contextValue.focusToErrorAfterSubmit = focusToErrorAfterSubmit;
	  contextValue.elementFocusHandler = elementFocusHandler;
	  return /*#__PURE__*/React.createElement(ReactValidatableFormContext.Provider, {
	    value: contextValue
	  }, props.children);
	};

	var getNative = _getNative;

	var defineProperty$1 = (function() {
	  try {
	    var func = getNative(Object, 'defineProperty');
	    func({}, '', {});
	    return func;
	  } catch (e) {}
	}());

	var _defineProperty = defineProperty$1;

	var defineProperty = _defineProperty;

	/**
	 * The base implementation of `assignValue` and `assignMergeValue` without
	 * value checks.
	 *
	 * @private
	 * @param {Object} object The object to modify.
	 * @param {string} key The key of the property to assign.
	 * @param {*} value The value to assign.
	 */
	function baseAssignValue$1(object, key, value) {
	  if (key == '__proto__' && defineProperty) {
	    defineProperty(object, key, {
	      'configurable': true,
	      'enumerable': true,
	      'value': value,
	      'writable': true
	    });
	  } else {
	    object[key] = value;
	  }
	}

	var _baseAssignValue = baseAssignValue$1;

	var baseAssignValue = _baseAssignValue,
	    eq = eq_1;

	/** Used for built-in method references. */
	var objectProto = Object.prototype;

	/** Used to check objects for own properties. */
	var hasOwnProperty = objectProto.hasOwnProperty;

	/**
	 * Assigns `value` to `key` of `object` if the existing value is not equivalent
	 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
	 * for equality comparisons.
	 *
	 * @private
	 * @param {Object} object The object to modify.
	 * @param {string} key The key of the property to assign.
	 * @param {*} value The value to assign.
	 */
	function assignValue$1(object, key, value) {
	  var objValue = object[key];
	  if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
	      (value === undefined && !(key in object))) {
	    baseAssignValue(object, key, value);
	  }
	}

	var _assignValue = assignValue$1;

	/** Used as references for various `Number` constants. */

	var MAX_SAFE_INTEGER = 9007199254740991;

	/** Used to detect unsigned integer values. */
	var reIsUint = /^(?:0|[1-9]\d*)$/;

	/**
	 * Checks if `value` is a valid array-like index.
	 *
	 * @private
	 * @param {*} value The value to check.
	 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
	 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
	 */
	function isIndex$1(value, length) {
	  var type = typeof value;
	  length = length == null ? MAX_SAFE_INTEGER : length;

	  return !!length &&
	    (type == 'number' ||
	      (type != 'symbol' && reIsUint.test(value))) &&
	        (value > -1 && value % 1 == 0 && value < length);
	}

	var _isIndex = isIndex$1;

	var assignValue = _assignValue,
	    castPath$1 = _castPath,
	    isIndex = _isIndex,
	    isObject = isObject_1,
	    toKey$1 = _toKey;

	/**
	 * The base implementation of `_.set`.
	 *
	 * @private
	 * @param {Object} object The object to modify.
	 * @param {Array|string} path The path of the property to set.
	 * @param {*} value The value to set.
	 * @param {Function} [customizer] The function to customize path creation.
	 * @returns {Object} Returns `object`.
	 */
	function baseSet$1(object, path, value, customizer) {
	  if (!isObject(object)) {
	    return object;
	  }
	  path = castPath$1(path, object);

	  var index = -1,
	      length = path.length,
	      lastIndex = length - 1,
	      nested = object;

	  while (nested != null && ++index < length) {
	    var key = toKey$1(path[index]),
	        newValue = value;

	    if (key === '__proto__' || key === 'constructor' || key === 'prototype') {
	      return object;
	    }

	    if (index != lastIndex) {
	      var objValue = nested[key];
	      newValue = customizer ? customizer(objValue, key, nested) : undefined;
	      if (newValue === undefined) {
	        newValue = isObject(objValue)
	          ? objValue
	          : (isIndex(path[index + 1]) ? [] : {});
	      }
	    }
	    assignValue(nested, key, newValue);
	    nested = nested[key];
	  }
	  return object;
	}

	var _baseSet = baseSet$1;

	var baseSet = _baseSet;

	/**
	 * Sets the value at `path` of `object`. If a portion of `path` doesn't exist,
	 * it's created. Arrays are created for missing index properties while objects
	 * are created for all other missing properties. Use `_.setWith` to customize
	 * `path` creation.
	 *
	 * **Note:** This method mutates `object`.
	 *
	 * @static
	 * @memberOf _
	 * @since 3.7.0
	 * @category Object
	 * @param {Object} object The object to modify.
	 * @param {Array|string} path The path of the property to set.
	 * @param {*} value The value to set.
	 * @returns {Object} Returns `object`.
	 * @example
	 *
	 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
	 *
	 * _.set(object, 'a[0].b.c', 4);
	 * console.log(object.a[0].b.c);
	 * // => 4
	 *
	 * _.set(object, ['x', '0', 'y', 'z'], 5);
	 * console.log(object.x[0].y.z);
	 * // => 5
	 */
	function set(object, path, value) {
	  return object == null ? object : baseSet(object, path, value);
	}

	var set_1 = set;

	var set$1 = /*@__PURE__*/getDefaultExportFromCjs(set_1);

	/**
	 * Gets the last element of `array`.
	 *
	 * @static
	 * @memberOf _
	 * @since 0.1.0
	 * @category Array
	 * @param {Array} array The array to query.
	 * @returns {*} Returns the last element of `array`.
	 * @example
	 *
	 * _.last([1, 2, 3]);
	 * // => 3
	 */

	function last$1(array) {
	  var length = array == null ? 0 : array.length;
	  return length ? array[length - 1] : undefined;
	}

	var last_1 = last$1;

	/**
	 * The base implementation of `_.slice` without an iteratee call guard.
	 *
	 * @private
	 * @param {Array} array The array to slice.
	 * @param {number} [start=0] The start position.
	 * @param {number} [end=array.length] The end position.
	 * @returns {Array} Returns the slice of `array`.
	 */

	function baseSlice$1(array, start, end) {
	  var index = -1,
	      length = array.length;

	  if (start < 0) {
	    start = -start > length ? 0 : (length + start);
	  }
	  end = end > length ? length : end;
	  if (end < 0) {
	    end += length;
	  }
	  length = start > end ? 0 : ((end - start) >>> 0);
	  start >>>= 0;

	  var result = Array(length);
	  while (++index < length) {
	    result[index] = array[index + start];
	  }
	  return result;
	}

	var _baseSlice = baseSlice$1;

	var baseGet = _baseGet,
	    baseSlice = _baseSlice;

	/**
	 * Gets the parent value at `path` of `object`.
	 *
	 * @private
	 * @param {Object} object The object to query.
	 * @param {Array} path The path to get the parent value of.
	 * @returns {*} Returns the parent value.
	 */
	function parent$1(object, path) {
	  return path.length < 2 ? object : baseGet(object, baseSlice(path, 0, -1));
	}

	var _parent = parent$1;

	var castPath = _castPath,
	    last = last_1,
	    parent = _parent,
	    toKey = _toKey;

	/**
	 * The base implementation of `_.unset`.
	 *
	 * @private
	 * @param {Object} object The object to modify.
	 * @param {Array|string} path The property path to unset.
	 * @returns {boolean} Returns `true` if the property is deleted, else `false`.
	 */
	function baseUnset$1(object, path) {
	  path = castPath(path, object);
	  object = parent(object, path);
	  return object == null || delete object[toKey(last(path))];
	}

	var _baseUnset = baseUnset$1;

	var baseUnset = _baseUnset;

	/**
	 * Removes the property at `path` of `object`.
	 *
	 * **Note:** This method mutates `object`.
	 *
	 * @static
	 * @memberOf _
	 * @since 4.0.0
	 * @category Object
	 * @param {Object} object The object to modify.
	 * @param {Array|string} path The path of the property to unset.
	 * @returns {boolean} Returns `true` if the property is deleted, else `false`.
	 * @example
	 *
	 * var object = { 'a': [{ 'b': { 'c': 7 } }] };
	 * _.unset(object, 'a[0].b.c');
	 * // => true
	 *
	 * console.log(object);
	 * // => { 'a': [{ 'b': {} }] };
	 *
	 * _.unset(object, ['a', '0', 'b', 'c']);
	 * // => true
	 *
	 * console.log(object);
	 * // => { 'a': [{ 'b': {} }] };
	 */
	function unset(object, path) {
	  return object == null ? true : baseUnset(object, path);
	}

	var unset_1 = unset;

	var unset$1 = /*@__PURE__*/getDefaultExportFromCjs(unset_1);

	const findDuplicates = arry => arry.filter((item, index) => arry.indexOf(item) !== index);
	const immediatelyFocusToHtmlElementWithGivenId = elementId => {
	  const element = document.getElementById(elementId);
	  if (!element) {
	    console.warn(`useValidatableForm warning. Dom element with id ${elementId} is not found to be focused`);
	  } else {
	    element.focus();
	  }
	};
	const getFinalPropValueFromHookOrContext = (key, hookProps, context) => {
	  let finalVal = false;
	  if (!isNullOrUndefined(context[key])) {
	    finalVal = context[key];
	  }
	  if (!isNullOrUndefined(hookProps[key])) {
	    finalVal = hookProps[key];
	  }
	  return finalVal;
	};
	const useValidatableForm = props => {
	  const {
	    rules,
	    initialFormData = {},
	    elementFocusHandler
	  } = props;
	  const context = React.useContext(ReactValidatableFormContext);
	  const [currentFormData, setCurrentFormData] = React.useState(initialFormData);
	  const [currentRules, setCurrentRules] = React.useState(rules);
	  const [formIsSubmitted, setFormIsSubmitted] = React.useState(false);
	  const [blurredPathList, setBlurredPathList] = React.useState([]);
	  const [validationErrorOriginalResult, setValidationErrorOriginalResult] = React.useState({});
	  if (!context) {
	    throw new Error('useValidatableForm hook must be used inside ReactValidatableFormProvider context');
	  }
	  React.useEffect(() => {
	    runValidations();
	  }, [context]);
	  React.useEffect(() => {
	    if (currentRules) {
	      if (!isArray(currentRules)) {
	        throw new Error(`useValidatableForm error. "rules" should be an array`);
	      }
	      const pathsOfCurrentRules = currentRules.map(cr => cr.path).filter(cr => cr);
	      const duplicatePaths = findDuplicates(pathsOfCurrentRules);
	      if (duplicatePaths && duplicatePaths.length > 0) {
	        throw new Error(`useValidatableForm error. Duplicate path keys found on rules: ${duplicatePaths}`);
	      }
	      const listPathsOfCurrentRules = currentRules.map(cr => cr.listPath).filter(cr => cr);
	      const duplicateListPaths = findDuplicates(listPathsOfCurrentRules);
	      if (duplicateListPaths && duplicateListPaths.length > 0) {
	        throw new Error(`useValidatableForm error. Duplicate listPath keys found on rules: ${duplicateListPaths}`);
	      }
	    }
	  }, [currentRules]);
	  const handleSetFormIsSubmitted = () => {
	    setFormIsSubmitted(true);
	    let finalFocusToErrorAfterSubmit = getFinalPropValueFromHookOrContext('focusToErrorAfterSubmit', props, context);
	    if (!isValid && finalFocusToErrorAfterSubmit) {
	      const focusToElementFunction = elementFocusHandler || context.elementFocusHandler || immediatelyFocusToHtmlElementWithGivenId;
	      for (const ruleDef of currentRules) {
	        if (!ruleDef.disableFocusAfterSubmit) {
	          const path = ruleDef.path;
	          const elementId = ruleDef.elementId;
	          const listPath = ruleDef.listPath;
	          const listElementId = ruleDef.listElementId;
	          const subRules = ruleDef.subRules;
	          let scrollableList = [];
	          if (listPath) {
	            if (subRules) {
	              const fullElementIdPrefix = listElementId || listPath;
	              const listData = get$1(currentFormData, listPath);
	              if (listData && listData.length > 0) {
	                for (let j = 0; j < listData.length; j++) {
	                  for (const subRule of subRules) {
	                    if (!subRule.disableFocusAfterSubmit) {
	                      const subRulePath = subRule.path;
	                      const subElementId = subRule.elementId || subRulePath;
	                      scrollableList.push({
	                        fullPath: `${listPath}{${j}}.${subRulePath}`,
	                        fullElementId: `${fullElementIdPrefix}{${j}}.${subElementId}`
	                      });
	                    }
	                  }
	                }
	              }
	            } else {
	              const fullElementIdPrefix = listElementId || listPath;
	              const listData = get$1(currentFormData, listPath);
	              if (listData && listData.length > 0) {
	                for (let j = 0; j < listData.length; j++) {
	                  scrollableList.push({
	                    fullPath: `${listPath}{${j}}`,
	                    fullElementId: `${fullElementIdPrefix}{${j}}`
	                  });
	                }
	              }
	            }
	          } else {
	            const fullElementId = elementId || path;
	            scrollableList.push({
	              fullPath: path,
	              fullElementId: fullElementId
	            });
	          }
	          if (scrollableList && scrollableList.length > 0) {
	            for (const scrollableObject of scrollableList) {
	              const fullPath = scrollableObject.fullPath;
	              const fullElementId = scrollableObject.fullElementId;
	              if (validationErrorOriginalResult[fullPath] && fullElementId) {
	                focusToElementFunction(fullElementId);
	                return isValid;
	              }
	            }
	          }
	        }
	      }
	    }
	    return isValid;
	  };
	  const resetForm = () => {
	    setFormIsSubmitted(false);
	    setBlurredPathList([]);
	  };
	  const runValidations = runParams => {
	    setValidationErrorOriginalResult(latestValidationErrorOriginalResult => {
	      const {
	        newFormData,
	        newRules,
	        pathToBeRun
	      } = runParams || {};
	      const rules = newRules ? newRules : currentRules;
	      const formData = newFormData ? newFormData : currentFormData;
	      const validationParams = {
	        currentValidationError: latestValidationErrorOriginalResult,
	        context,
	        rules,
	        formData: formData || {},
	        pathToBeRun
	      };
	      const newValidationErrorOriginalResult = handleValidationsOfForm(validationParams);
	      return newValidationErrorOriginalResult;
	    });
	  };
	  const setPathValue = React.useCallback((path, value) => {
	    if (!isString(path)) {
	      throw new Error(`useValidatableForm error. "path" parameter of setPathValue should be a string`);
	    }
	    setCurrentFormData(latestFormData => {
	      const newFormData = {
	        ...latestFormData
	      };
	      set$1(newFormData, path, value);
	      let pathToBeRun = path;
	      runValidations({
	        newFormData,
	        pathToBeRun
	      });
	      return newFormData;
	    });
	  }, [context, currentRules, setCurrentFormData, setValidationErrorOriginalResult]);
	  const unsetPathValue = React.useCallback(path => {
	    if (!isString(path)) {
	      throw new Error(`useValidatableForm error. "path" parameter of unsetPathValue should be a string`);
	    }
	    setCurrentFormData(latestFormData => {
	      const newFormData = {
	        ...latestFormData
	      };
	      unset$1(newFormData, path);
	      let pathToBeRun = path;
	      runValidations({
	        newFormData,
	        pathToBeRun
	      });
	      return newFormData;
	    });
	  }, [context, currentRules, setCurrentFormData, setValidationErrorOriginalResult]);
	  const handleSetCurrentRules = newRules => {
	    if (!newRules) {
	      newRules = [];
	    }
	    runValidations({
	      newRules
	    });
	    setCurrentRules(newRules);
	  };
	  const handleSetFormData = (newFormData, pathToBeRun) => {
	    if (!newFormData) {
	      newFormData = {};
	    }
	    runValidations({
	      newFormData,
	      pathToBeRun
	    });
	    setCurrentFormData(newFormData);
	  };
	  const handleSetFormDataAndCurrentRules = (newFormData, newRules) => {
	    if (!newFormData) {
	      newFormData = {};
	    }
	    if (!newRules) {
	      newRules = [];
	    }
	    runValidations({
	      newFormData,
	      newRules
	    });
	    setCurrentRules(newRules);
	    setCurrentFormData(newFormData);
	  };
	  const setPathIsBlurred = React.useCallback(path => {
	    if (path) {
	      if (!isString(path)) {
	        throw new Error(`useValidatableForm error. "path" parameter of setPathIsBlurred should be a string`);
	      }
	      setBlurredPathList(latestBlurredPathList => {
	        const newBlurredPathList = [...latestBlurredPathList];
	        if (!newBlurredPathList.includes(path)) {
	          newBlurredPathList.push(path);
	        }
	        return newBlurredPathList;
	      });
	    }
	  }, [context, currentRules, setBlurredPathList, setValidationErrorOriginalResult]);
	  const unsetPathIsBlurred = React.useCallback(path => {
	    if (path) {
	      if (!isString(path)) {
	        throw new Error(`useValidatableForm error. "path" parameter of unsetPathIsBlurred should be a string`);
	      }
	      setBlurredPathList(latestBlurredPathList => {
	        const newBlurredPathList = latestBlurredPathList.filter(p => {
	          return p !== path;
	        });
	        return newBlurredPathList;
	      });
	    }
	  }, [context, currentRules, setBlurredPathList, setValidationErrorOriginalResult]);
	  const isValid = Object.keys(validationErrorOriginalResult).length < 1;
	  let validationError = {
	    ...validationErrorOriginalResult
	  };
	  let finalHideBeforeSubmit = getFinalPropValueFromHookOrContext('hideBeforeSubmit', props, context);
	  if (finalHideBeforeSubmit && !formIsSubmitted) {
	    let finalShowAfterBlur = getFinalPropValueFromHookOrContext('showAfterBlur', props, context);
	    if (finalShowAfterBlur) {
	      Object.keys(validationErrorOriginalResult).forEach(pathForFocus => {
	        if (!blurredPathList.includes(pathForFocus)) {
	          delete validationError[pathForFocus];
	        }
	      });
	    } else {
	      validationError = {};
	    }
	  }
	  const getValue = path => {
	    return get$1(currentFormData, path);
	  };
	  const getError = path => {
	    return get$1(validationError, path);
	  };
	  const isPathValid = path => {
	    if (blurredPathList.includes(path) || formIsSubmitted) {
	      return !get$1(validationError, path);
	    }
	    return false;
	  };
	  return {
	    isValid: isValid,
	    validationError: validationError,
	    validationErrorOriginalResult: validationErrorOriginalResult,
	    formData: currentFormData || {},
	    formIsSubmitted: formIsSubmitted,
	    blurredPathList: blurredPathList,
	    forceRunAllValidations: runValidations,
	    resetForm: resetForm,
	    setPathValue: setPathValue,
	    unsetPathValue: unsetPathValue,
	    setFormData: handleSetFormData,
	    setRules: handleSetCurrentRules,
	    setFormDataAndRules: handleSetFormDataAndCurrentRules,
	    setFormIsSubmitted: handleSetFormIsSubmitted,
	    setPathIsBlurred: setPathIsBlurred,
	    unsetPathIsBlurred: unsetPathIsBlurred,
	    getValue: getValue,
	    getError: getError,
	    isPathValid: isPathValid
	  };
	};

	exports.ReactValidatableFormProvider = ReactValidatableFormProvider;
	exports.useValidatableForm = useValidatableForm;

}));
